unit fMain;

interface

uses
  Windows, Graphics, Forms, Classes, Controls, StdCtrls, Dialogs, Grids;
  
type
  TByteSet = set of Byte;
  TBytes = array of Byte;

  TfrmMain = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    Done: Boolean;
    ResultTable: array[0..8, 0..8] of Byte;    //̫ᲣXG
  public
    function SetToBytes(ASet: TByteSet; Range: Integer): TBytes;
    function ColSet(Index: Integer): TByteSet;
    function RowSet(Index: Integer): TByteSet;
  end;

var
  frmMain: TfrmMain;

implementation

uses SysUtils;

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Randomize;
  Width := 470;
  Height := 400;
end;

procedure TfrmMain.Button1Click(Sender: TObject);
var
  Sudos: TBytes;
  I, K, L, C, R: Byte;
  S: array[0..2] of TByteSet;
  AreaSet: array[0..8] of TByteSet;//@
begin
  Sudos := nil;
  repeat
    Done := True;
    for I := 0 to 8 do AreaSet[I] := [];
    FillChar(ResultTable, SizeOf(ResultTable), $FF);
    for I := 0 to 80 do
    begin
      C := I mod 9;
      R := I div 9;
      K := (R div 3) * 3 + (C div 3);
      S[0] := [0..8] - ColSet(C);     //Column Available SudoSet
      S[1] := [0..8] - RowSet(R);     //Row Available SudoSet
      S[2] := [0..8] - AreaSet[K];   //Area Available SudoSet
      S[0] := S[0] * S[1] * S[2];     //Intersection: The Available SudoSet
      if S[0] = [] then Done := False
      else begin
        Sudos := SetToBytes(S[0], 9);     //Random Selection
        L := Sudos[Random(Length(Sudos))];
        AreaSet[K] := AreaSet[K] + [L]; 
        ResultTable[C, R] := L;
      end;
    end;
  until Done;

  Repaint;//øXŪ
          
end;

function TfrmMain.SetToBytes(ASet: TByteSet; Range: Integer): TBytes;
var
  I, J: Byte;
begin
  SetLength(Result, Range);
  J := 0;
  for I := 0 to Range-1 do
  begin
    if I in ASet then
    begin
      Result[J] := I;
      ASet := ASet - [I];
      Inc(J);
    end;
    if ASet = [] then Break;
  end;
  SetLength(Result, J);
end;

function TfrmMain.ColSet(Index: Integer): TByteSet;
var
  I: Integer;
begin
  Result := [];
  for I := 0 to 8 do
    if ResultTable[Index, I] <> $FF then
      Result := Result + [ResultTable[Index, I]];
end;

function TfrmMain.RowSet(Index: Integer): TByteSet;
var
  I: Integer;
begin
  Result := [];
  for I := 0 to 8 do
    if ResultTable[I, Index] <> $FF then
      Result := Result + [ResultTable[I, Index]];
end;

procedure TfrmMain.FormPaint(Sender: TObject);
const
  CW = 40;
  RH = 40;

  procedure SetPen(Color: TColor; Width: Integer; Style: TPenStyle; Mode: TPenMode);
  begin
    Canvas.Pen.Color := Color;
    Canvas.Pen.Width := Width;
    Canvas.Pen.Style := Style;
    Canvas.Pen.Mode := Mode;
  end;

  procedure SetBrush(Color: TColor; Style: TBrushStyle);
  begin
    Canvas.Brush.Color := Color;
    Canvas.Brush.Style := Style;
  end;

  procedure SetFont(Name: string; Height: Integer; Color: TColor; Style: TFontStyles);
  begin
    Canvas.Font.Name := Name;
    Canvas.Font.Height := Height;
    Canvas.Font.Color := Color;
    Canvas.Font.Style := Style;
  end;

  procedure Clear;
  var
    rt: TRect;
  begin
    SetPen(clGray, 1, psSolid, pmCopy);
    SetBrush(clSilver, bsSolid);
    rt := Rect(0, 0, CW*9-8, RH*9-8);
    OffsetRect(rt, 10, 10);
    Canvas.Rectangle(rt);
  end;

  procedure DrawCols;
  var
    I: Integer;
    rt: TRect;
  begin
    SetPen(clSilver, 1, psSolid, pmCopy);
    SetBrush(clGray, bsSolid);
    rt := Rect(0, 0, CW*9-8, RH);
    OffsetRect(rt, 10, 10);
    for I := 0 to 8 do
    begin
      Canvas.FrameRect(rt);
      OffsetRect(rt, 0, RH-1);
    end;
  end;

  procedure DrawRows;
  var
    I: Integer;
    rt: TRect;
  begin
    SetPen(clSilver, 1, psSolid, pmCopy);
    SetBrush(clGray, bsSolid);
    rt := Rect(0, 0, CW, RH*9-8);
    OffsetRect(rt, 10, 10);
    for I := 0 to 8 do
    begin
      Canvas.FrameRect(rt);
      OffsetRect(rt, CW-1, 0);
    end;
  end;

  procedure DrawContents;
  var
    I, J: Integer;
    rt: TRect;
    S: string;
  begin
    SetBrush(clGray, bsSolid);
    SetFont('ARIAL',36,clWhite,[fsBold]);
    for I := 0 to 8 do
      for J := 0 to 8 do
      begin
        rt := Rect((CW-1)*I, (RH-1)*J, (CW-1)*(I+1), (RH-1)*(J+1));
        OffsetRect(rt, 10, 10);
        InflateRect(rt, -2, -2);
        Inc(rt.Right);
        Inc(rt.Bottom);
        S := IntToStr(ResultTable[I, J]+1);
        Canvas.TextRect(Rt, Rt.Left+10, Rt.Top+2, S);
      end;
  end;

  procedure DrawCols2;
  var
    I: Integer;
    rt: TRect;
  begin
    SetPen(clSilver, 1, psSolid, pmCopy);
    SetBrush(clRed, bsSolid);
    rt := Rect(0, 0, CW*9-8, RH*3-2);
    OffsetRect(rt, 10, 10);
    for I := 0 to 2 do
    begin
      Canvas.FrameRect(rt);
      OffsetRect(rt, 0, (RH-1)*3);
    end;
  end;

  procedure DrawRows2;
  var
    I: Integer;
    rt: TRect;
  begin
    SetPen(clSilver, 1, psSolid, pmCopy);
    SetBrush(clRed, bsSolid);
    rt := Rect(0, 0, CW*3-2, RH*9-8);
    OffsetRect(rt, 10, 10);
    for I := 0 to 2 do
    begin
      Canvas.FrameRect(rt);
      OffsetRect(rt, (CW-1)*3, 0);
    end;
  end;

begin
  Clear;
  DrawCols;
  DrawRows;
  DrawCols2;
  DrawRows2;
  if Done then
    DrawContents;
end;

end.
